<?php

// Include the main TCPDF library (search for installation path).
require_once('tcpdf/tcpdf.php');

// Extend the TCPDF class to create custom Header and Footer
class MYPDF_PDF extends TCPDF {

	//Page header
	public function Header() {
		// Logo
	/*	$image_file = K_PATH_IMAGES.'logo_example.jpg';
		$this->Image($image_file, 10, 10, 15, '', 'JPG', '', 'T', false, 300, '', false, false, 0, false, false, false);
		// Set font
		$this->SetFont('helvetica', 'B', 20);
		// Title
		$this->Cell(0, 15, '<< TCPDF Example 003 >>', 0, false, 'C', 0, '', 0, false, 'M', 'M');*/
	}

	// Page footer
	public function Footer() {
		// Position at 15 mm from bottom
		$this->SetY(-10);
		// Set font
		$this->SetFont('helvetica', 'I', 6);
		// Page number
		//$this->Cell(0, 10, 'Página '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
		//$this->Cell(0, 0, 'Descargue factura desde: https://elcondadoquito.factura9.com'.'', 0, false, 'L', 0, '', 0, '', 'T', 'M');
		//$this->Cell(60,5,$total1,'',0,'R');
		$this->Cell(0, 0, 'Descargue su factura desde:'.'', 0, false, 'C', 0, '', 0, false, 'T', 'M');
		$this->SetY(-7);
		$this->Cell(0, 0, 'https://elcondadoquito.factura9.com '.'', 0, false, 'C', 0, '', 0, false, 'T', 'M');
	}
	
	public function cabecera($empresaid,$clavef){
	    $this->SetY(10);
        $this->Cell(20,6,$clavef,0,0,'C','');
        $this->Cell(20,6,'Autorizado',0,0,'C','');
        //$this->Cell(40,6,$ruc,0,0,'C','');
    } 
    
    function inicio($erazons,$enombrec,$eruc,$fnumeroe,$edireccion,$ecespecial,$eocontab,$crazons,$cruc,$ffechac,$descta,$desctipoe,$clavep,$cdireccion,$tipo,$dirsucursal){
		//substr($nprove1,80)
	//$this->Ln();
	if ($tipo == 'F'){
		$titulo = 'FACTURA';
	}	elseif ($tipo == 'R'){
		$titulo = 'COMPROBANTE DE RETENCION';
	}	elseif ($tipo == 'G'){
		$titulo = 'GUIA DE REMISION';
	}	elseif ($tipo == 'LQ'){
		$titulo = 'LIQUIDACION DE COMPRA DE BIENES Y SERVICIOS';
	}
	$this->SetY(5);
	$this->SetFont('helvetica','B',9);
	$this->Cell(100,30,' ',0,0,'C');
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(90,10,'RUC '.$eruc,'TRL',1,'L'); //Titulo del reporte	
	$this->Cell(100,10,' ',0,0,'C'); //Titulo del reporte
	
	$this->Cell(1,5,'',0,0,'L');	
	$this->Cell(90,10,$titulo,'RL',1,'L');
	$this->Cell(100,10,' ',0,0,'C');
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(10,10,'No','L',0,'L'); 
	$this->Cell(80,10,''.substr($fnumeroe,0,3).'-'.substr($fnumeroe,3,3).'-'.substr($fnumeroe,6,9),'R',1,'C');
	$this->Cell(100,10,' ',0,0,'C');
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(90,10,'NUMERO AUTORIZACION','LR',1,'L'); 
	$this->Cell(100,10,' ',0,0,'C');
	$this->SetFont('helvetica','',8);
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(90,10,$clavep,'LR',1,'L');
	$this->Cell(100,10,' ',0,0,'C'); 
	
	if ($eocontab== 'S'){
		$eocontab2= 'SI';
	} else {
		$eocontab2= 'NO';
	}
	
	$this->Cell(1,5,'',0,0,'L');
	$this->SetFont('helvetica','B',7);
	$this->Cell(20,10,'AMBIENTE','L',0,'L');
	$this->SetFont('helvetica','',7); 
	$this->Cell(70,10,''.$descta,'R',1,'L');
	$this->Cell(100,10,' ',0,0,'C');
	//$this->Cell(90,10,'',0,1,'C');
	$this->Cell(1,5,'',0,0,'L');
	$this->SetFont('helvetica','B',7);
	$this->Cell(20,10,'EMISION','L',0,'L'); 
	$this->SetFont('helvetica','',7);
	$this->Cell(70,10,''.$desctipoe,'R',1,'L');
	
	//$this->Cell(80,40,'',1,0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','B',7);
	$this->Cell(100,5,utf8_decode($erazons),'TRL',0,'L'); //Titulo del reporte
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(90,5,'   ','RL',1,'L');
	$this->SetFont('helvetica','B',7);
	//$this->Cell(100,5,'Direccion Matriz:'.$edireccion,'RL',0,'L'); //Titulo del reporte
	$this->Cell(30,5,utf8_decode('Direccion Matriz: '),'L',0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','',7);
	$this->Cell(70,5,utf8_decode(substr($edireccion,0,79)),'R',0,'L');
	$this->Cell(1,5,'',0,0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','',7);
	$nprove = '';
	$this->Cell(90,5,''.substr($nprove,0,79),'RL',1,'L'); //Ruc en la tabla Empresac
	$this->SetFont('helvetica','B',7);
	//$this->Cell(100,5,'Direccion Sucursal: '.$edireccion,'RL',0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','B',7);
	$this->Cell(30,5,utf8_decode('Direccion Sucursal: '),'L',0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','',7);
	$this->Cell(70,5,utf8_decode($dirsucursal),'R',0,'L');
	//$this->Cell(15,7,'',0,0,'L'); //Titulo del reporte
	$this->Cell(1,5,'',0,0,'L');
	$nruc = '';
	$this->Cell(90,5,''.$nruc,'LR',1,'L'); //Titulo del reporte
	$this->SetFont('helvetica','B',7);
	$this->Cell(40,5,'Contribuyente Especial Nro:  ','L',0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','',7);
	$this->Cell(60,5,$ecespecial,'R',0,'L');
	//$this->Cell(15,7,'',0,0,'L'); //Titulo del reporte
	$this->Cell(1,5,'',0,0,'L');
	$this->SetFont('helvetica','',8);
	$this->Cell(90,5,'CLAVE DE ACCESO','RL',1,'C');
	$this->SetFont('helvetica','B',7);
	
	$this->Cell(40,5,'Obligado a llevar Contabilidad:  ','L',0,'L'); //Titulo del reporte
	$this->SetFont('helvetica','',7);
	$this->Cell(60,5,$eocontab2,'R',0,'L');
	//$this->Cell(15,7,'',0,0,'L'); 
	$this->Cell(1,5,'',0,0,'L');
	$this->code128(115,80,$clavep,80,10);
	$this->Cell(90,5,$clavep,'RL',1,'C'); //Titulo del reporte
	$this->Cell(100,5,'','LRB',0,'C'); //Titulo del reporte
	$this->Cell(1,5,'',0,0,'L');
	$this->Cell(90,5,'','RLB',1,'L');
	$this->Cell(90,2,'',0,1,'L');
	// Datos Cliente
	if ($tipo != 'G'){
		$this->SetFont('helvetica','',8);
		$this->SetXY(50,107);
		$y1 = $this->GetY();
		$x1 = $this->GetX();	
		$this->SetFillColor(255,255,255);
		if (strlen(trim($crazons)) >= 56){
			$this->Cell(100,5,''.substr($crazons,0,55),'T',0,'L');
			$slinea = 'T';
		}	else {
			$this->Cell(100,5,''.$crazons,'T',0,'L');
			$slinea = 'F';
		}	
		
		$y2 = $this->GetY();
		//$alto = $y2 - $y1 ;
		$alto = 5 ;
		$this->SetFont('helvetica','B',9);
		$this->SetXY(150,107);
		$this->Cell(25,$alto,utf8_decode('Identificacion'),'T',0,'L');
		//$this->SetFont('helvetica','B',9);
		$this->SetXY(10,107);
		$this->Cell(40,$alto,utf8_decode('Razon Social / Nombres: '),'TL',0,'L'); //Titulo del reporte
		$this->SetXY(175,107);
		$this->SetFont('helvetica','',8);
		$this->Cell(26,$alto,''.$cruc,'TR',1,'L');
		if ($slinea == 'T'){
			$this->SetXY(10,112);
			$this->Cell(191,5,''.utf8_decode(substr($crazons,55,119)),'LR',1,'L');
		}	
		
		$this->SetFont('helvetica','B',9);
		$this->Cell(40,5,utf8_decode('Fecha emision '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(100,5,''.$ffechac,'',0,'L');
		$this->SetFont('helvetica','B',9);
		if ($tipo == 'F'){
			$etiguia= 'Guia de Remision';
		}	elseif ($tipo == 'R'){
			$etiguia= '';
		}
		$this->Cell(20,5,utf8_decode($etiguia),'',0,'L');
		$this->SetFont('helvetica','',8);
		$this->Cell(31,5,'','R',1,'L');
		if ($tipo == 'F'){
			$this->SetFont('helvetica','B',9);
			$this->Cell(40,5,utf8_decode('Direccion '),'BL',0,'L'); //Titulo del reporte
			$this->SetFont('helvetica','',8);
			$this->Cell(100,5,''.utf8_decode($cdireccion),'B',0,'L');
			$this->SetFont('helvetica','B',9);
			$this->Cell(20,5,utf8_decode(''),'B',0,'L');
			$this->SetFont('helvetica','',8);
			$this->Cell(31,5,'','RB',1,'L');
		}	elseif ($tipo == 'R' or $tipo == 'LQ'){ 
				$this->Cell(191,1,'','LRB',1,'L');
	  	}
	  	$this->Cell(90,2,'',0,1,'L');	
		
	}
	
	
	//
	}
	
	function detalle($factid,$cn,$crazons,$codaltpro){
		$sql = "SELECT f.productoServicioId,f.FacturaDetalleCantidad,f.FacturaDetalleNombre,f.FacturaDetallepvp,f.facturadetalledescuento,f.FacturaDetalleBaseImponible,f.FacturaDetalletimpIva,f.FacturaDetalleCodigoIva,f.FacturaDetallePorcentajeIva,
		f.FacturaDetalleValorIva,p.ProductoServicioNombre,p.ProductoServicioNomGenerico,p.ProductoServicioReferencia,p.ProductoServicioDescripcion FROM facturadetalle f, productoservicio p WHERE f.facturaid = $factid and f.ProductoServicioId = p.productoservicioid";
		if (!$resultado = $cn->query($sql)) {
		
    		echo "Lo sentimos, problemas al buscar detalle pdf interno.";
    		exit;
        }
    
 
			//Ahora mediante un bucle construimos el reporte 
			//Pero primero validemos si existen alumnos en ese curso nos cargue los datos
			//$numfilas = mysql_num_rows($listado);
			
			$varo = 0;
			if (strlen(trim($crazons)) >= 56){
				$ubicaf = 135;
			} else {
				$ubicaf = 130;
			}	
			 while($fila = $resultado->fetch_assoc()){ 
					 $tline = 0;
					 $tline = 0;
					 $tline= round($tline,2);
					 //buscadescripciona alterna
					 $traedesc = traedescemp($cn);
					 if ($traedesc == 0){
						 $descdet= $fila['ProductoServicioNombre'];
					 } elseif ($traedesc == 1){
						 $descdet= $fila['descripcionalterna'];
					 }
					 //$descdet = $fila['ProductoServicioNombre'];				 
					 $descadic = $fila['FacturaDetalleNombre'];
					 $totdesc = utf8_decode($descdet).' '.utf8_decode($descadic);
					 $numcar = strlen($totdesc);
					 echo 'numcar '.$numcar.'desc '.$totdesc;
					 //$alto = altofila($numcar);
					 $alto = 4;
					 $this->SetXY(45,$ubicaf);
					 $y1 = $this->GetY();
					 $x1 = $this->GetX(); 
					 $this->MultiCell(80,4,$totdesc,1,'l'); 
					 $y2 = $this->GetY();
			 		 $alto = $y2 - $y1 ;
					 $this->SetXY(10,$ubicaf);
					 if ($codaltpro == 0){
						$this->Cell(35,$alto,$fila['productoServicioId'],1,0);
					 } elseif ($codaltpro == 1){
						$this->Cell(35,$alto,$fila['ProductoServicioNomGenerico'],1,0);
					 } 
					  //id  
					 //Celda con ancho de 50, alto de 10, el dato, borde 1, sin salto de linea**
					 $this->SetXY(125,$ubicaf);
					 $this->Cell(15,$alto,$fila['FacturaDetalleCantidad'],1,0,'C'); //**
					 $this->SetXY(140,$ubicaf);
					 $precaux = $english_format_number = number_format($fila['FacturaDetallepvp'], 7, '.', '');
					 $this->Cell(20,$alto,$precaux,1,0,'R'); //** 
					 $this->SetXY(160,$ubicaf);
					 $precaux = $english_format_number = number_format($fila['facturadetalledescuento'], 2, '.', '');
					 $this->Cell(20,$alto,$precaux,1,0,'R'); //**
					 $this->SetXY(180,$ubicaf);
					 $precaux = $english_format_number = number_format($fila['FacturaDetalleBaseImponible'], 2, '.', '');
					 $this->Cell(21,$alto,$precaux,1,1,'R');
					 $ubicaf = $ubicaf + $alto;
					 echo 'inserta linea';
					 //$pdf->Cell(30,5,$fila['OCCotizacionDetalleTotal'],1,0,'R'); //**
					 //$pdf->Cell(10,5,$tline,1,0,'R'); //**
				 
				 //$pdf->Cell(20,10,$fila['OCCotizacionDetalleIce2'],1,0); //**
				 //OCCotizacionDetalleSubtotal
				 //OCCotizacionDetal35Iva2
				 //$pdf->Ln(); //Hacer el salto de linea para la siguiente fila del registro
				 //$varo = $varo + $fila['cofototala'];
				// $varo1 = $english_format_number = number_format($varo, 2, '.', '');
					

			}
	//$varo = round($varo,2);

		}
	
	
	function totales($fsubtotal,$fdescuento,$fiva,$ftotalimp,$cdireccion,$ctelefono,$cemail,$factid,$fsubtotal0,$fcomentario){
		//$this->Cell(15,7,'',0,0,'L');
		$totsub = $fsubtotal - $fsubtotal0;
		if ($totsub == 0 ){
			$sub12 = 0;
			$sub0 = $fsubtotal0;
		}  elseif($totsub == $fsubtotal){
			$sub12 = $fsubtotal;
			$sub0 = 0;
		}  elseif($totsub != $fsubtotal){
		    if ($fsubtotal == 0){
		      $sub12 = 0;
		    } else {      
			    $sub12 = $fsubtotal - $fsubtotal0;
		    }
			$sub0 = $fsubtotal0;
		}  
		$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'SUBTOTAL 12%',1,0,'l'); //Titulo del reporte
		$sub12 = $english_format_number = number_format($sub12, 2, '.', '');
		$this->Cell(21,5,$sub12,1,1,'R'); //Titulo del reporte
		
		
		
		$this->Cell(130,5,'INFORMACION ADICIONAL',0,0,'C');
		$this->Cell(40,5,'SUBTOTAL 0%',1,0,'l'); //Titulo del reporte
		$sub0 = $english_format_number = number_format($sub0, 2, '.', '');
		$this->Cell(21,5,$sub0,1,1,'R'); //Titulo del reporte
		
		
		$this->Cell(30,5,'OBSERVACIONES: ','TL',0,'L');
		$this->Cell(98,5,substr($fcomentario,0,60),'TR',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		$this->Cell(40,5,'SUBTOTAL NO SUJETO IVA',1,0,'l'); //Titulo del reporte
		$this->Cell(21,5,'0.00',1,1,'R'); //Titulo del reporte
	
		$this->Cell(128,5,substr($fcomentario,60,100),'RL',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		//$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'SUBTOTAL SIN IMPUESTOS',1,0,'l'); //Titulo del reporte
		$this->Cell(21,5,'0.00',1,1,'R'); //Titulo del reporte
		
		$this->Cell(28,5,"TELEFONO",'L',0,'L');
		$this->Cell(100,5,$ctelefono,'R',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		//$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'DESCUENTO',1,0,'l'); //Titulo del reporte
		$fdescuento = $english_format_number = number_format($fdescuento, 2, '.', '');
		$this->Cell(21,5,$fdescuento,1,1,'R'); //Titulo del reporte
		
		$this->Cell(128,5,'CORREO','LR',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		$this->Cell(40,5,'ICE',1,0,'l'); //Titulo del reporte
		$this->Cell(21,5,'0.00',1,1,'R'); //Titulo del reporte
		
		$this->Cell(128,5,$cemail,'RL',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		//$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'IVA 12%',1,0,'l'); //Titulo del reporte
		$fiva = $english_format_number = number_format($fiva, 2, '.', '');
		$this->Cell(21,5,$fiva,1,1,'R'); //Titulo del reporte
		
		$this->Cell(28,5,'Referencia','BL',0,'L');
		$this->Cell(100,5,$factid,'BR',0,'L');
		$this->Cell(2,5,'',0,0,'L');
		//$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'PROPINA',1,0,'l'); //Titulo del reporte
		$this->Cell(21,5,'0.00',1,1,'R'); //Titulo del reporte
		
		$this->Cell(130,5,'',0,0,'L');
		$this->Cell(40,5,'VALOR TOTAL',1,0,'l'); //Titulo del reporte
		$ftotalimp = $english_format_number = number_format($ftotalimp, 2, '.', '');
		$this->Cell(21,5,$ftotalimp,1,1,'R'); //Titulo del reporte
	
	}
	
	
	function formaspago($factid,$cn,$eunidadtiempo){
		$sql = "SELECT d.FormaPagoId,d.detalleFormaPagoMonto,d.diasplazo,f.codigosri,f.descripcion FROM detalleformaspago d, formaspago f WHERE d.facturaid = $factid and d.codigosri = f.codigosri";
		if (!$resultado = $cn->query($sql)) {
		
    		echo "Lo sentimos, problemas al buscar formas pago pdf interno.";
    		exit;
        }
					
		$varo = 0;

		while($fila = $resultado->fetch_assoc()){ 
    		 $tline = 0;
    		 $tline = 0;
    		 $tline= round($tline,2);
    		 //$var1 = $fila['OCCotizacionDetalleDesc'];
    		 $this->Cell(78,4,$fila['descripcion'],1,0); //id 
    		 $preaux = $english_format_number = number_format($fila['detalleFormaPagoMonto'], 2, '.', '');					 
    		 $this->Cell(20,4,$preaux,1,0); //Celda con ancho de 50, alto de 10, el dato, borde 1, sin salto de linea**
    		 $this->Cell(10,4,$fila['diasplazo'],1,0,'C'); //**
    		 $this->Cell(20,4,$eunidadtiempo,1,1,'C');
		 //$this->Cell(20,4,$fila['FacturaDetallepvp'],1,0,'R'); //** 
		 //$pdf->Cell(30,5,$fila['OCCotizacionDetalleTotal'],1,0,'R'); //**
		 //$pdf->Cell(10,5,$tline,1,0,'R'); //**
	 
		 //$pdf->Cell(20,10,$fila['OCCotizacionDetalleIce2'],1,0); //**
		 //OCCotizacionDetalleSubtotal
		 //OCCotizacionDetal35Iva2
		 //$pdf->Ln(); //Hacer el salto de linea para la siguiente fila del registro
		 //$varo = $varo + $fila['cofototala'];
		// $varo1 = $english_format_number = number_format($varo, 2, '.', '');
					

			}
	//$varo = round($varo,2);

	}
		
	function fmemo($factid,$cn,$fmemo){
		$this->Ln();
		$this->SetFont('helvetica','',7);
		$this->MultiCell(120,4,utf8_decode($fmemo),0,'L');
	}	
	
	
	function fmensaje($cn,$mensaje3){
		$titulo = "CÓDIGO DE COMERCIO: Art.202.-";
		$titulo2 = "LEY RÉGIMEN TRIBUTARIO INTERNO";
		$mensaje4 = "Art. 50.- Obligaciones de los agentes de retención.- La retención en la fuente deberá realizarse al momento del pago o crédito en cuenta, 
		lo que suceda primero. Los agentes de retención están obligados a entregar el respectivo comprobante de retención, dentro del término no mayor de cinco días de recibido el comprobante de venta, a las personas a quienes deben efectuar la retención.  
		";
		$mensaje5 = traemensaje4($cn);
		$men54 = substr($mensaje5,0,64);
		$mentot = substr($mensaje5,65,250);
		$this->Ln();
		$this->SetTextColor(36,45,195);
		$this->SetFont('helvetica','B',7);
		$this->Cell(80,4,utf8_decode($titulo),0,1,'L');
		$this->SetFont('helvetica','',7);
		$this->MultiCell(190,4,utf8_decode($mensaje3),0,'J');
		$this->Ln();
		$this->SetFont('helvetica','B',7);
		$this->Cell(80,4,utf8_decode($titulo2),0,1,'L');
		$this->SetFont('helvetica','',7);
		$this->MultiCell(190,4,utf8_decode($mensaje4),0,'J');
		//$this->Ln();
		$this->SetFont('helvetica','B',7);
		$this->Cell(76,4,utf8_decode($men54),0,'J');
		$this->SetFont('helvetica','',7);
		$this->Cell(110,4,utf8_decode(substr($mentot,0,102)),0,'J');
		$this->Ln();
		$this->Cell(100,4,utf8_decode(substr($mentot,102,250)),0,'J');
	}	
	
	function fmensaje4($cn){
	  $mensaje4 = traemensaje4($cn);
	  $this->SetFont('helvetica','B',9);
	  $this->Ln();
	  $this->MultiCell(190,4,utf8_decode($mensaje4),0,'J');
	}
	
	function fmensaje5($cn){
	  $mensaje5 = traemensaje5($cn);
	  $this->SetFont('helvetica','B',9);
	  $this->Ln();
	  $this->MultiCell(190,4,utf8_decode($mensaje5),0,'J');
	}
	
	
	function detalleret($factid,$cn,$rscliente,$numfactura,$ffechac,$fechaefiscal){
    	$sql = "SELECT f.tiporetencion as tiporetencion,f.RetencionBaseRetencion,f.RetencionValorRetenido,f.RetencionPorcentaje, r.tiporetencioncodigo  
    	FROM retenciondetalle f, retenciones r WHERE f.retencionid= $factid and f.retencionid= r.retencionid" ;
    	
    	if (!$resultado = $cn->query($sql)) {
		
    		echo "Lo sentimos, problemas al buscar formas pago pdf interno.";
    		exit;
        }
					
		$totret = 0;

		while($fila2 = $resultado->fetch_assoc()){ 
			$coddocsustento = $fila2['tiporetencioncodigo'];;
			if (strlen(trim($rscliente)) >= 50){
				$ubicaf = 140;
			} else {
				$ubicaf = 130;
			}
			$fact = traetiporetencion($cn,$coddocsustento);
			/*if ($coddocsustento == '01'){
				$fact = 'FACTURA';
			}*/
			//$ffechas = cambiafecha($fila2['fechaemisiondocsustento']);
			//$fejercicio = substr($ffechas,3,10);
			$tipofila = $fila2['tiporetencion'];
			if ($tipofila == '2'){
				$ivarent = 'RENTA';
			}	elseif ($tipofila == '1') {
				$ivarent = 'IVA';	
			}	
			 $this->SetFont('helvetica','',8);		 
			 $this->Cell(55,4,$fact,1,0,'L'); //Celda con ancho de 50, alto de 10, el dato, borde 1, sin salto de linea**
			 $this->Cell(30,4,substr($numfactura,0,3).'-'.substr($numfactura,3,3).'-'.substr($numfactura,6,9),1,0); //id  
			 $this->Cell(20,4,$ffechac,1,0,'C'); //**
			 $this->Cell(15,4,$fechaefiscal,1,0,'R'); //** 
			 $baseimp = $fila2['RetencionBaseRetencion'];
			 $baseimp = $english_format_number = number_format($baseimp, 2, '.', '');
			 $this->Cell(20,4,$baseimp,1,0,'R'); //**
			 $this->Cell(12,4,$ivarent,1,0,'R');
			 $this->Cell(18,4,$fila2['RetencionPorcentaje'],1,0,'R');
			 $valor = $fila2['RetencionValorRetenido'];
			 $totret = $totret + $valor;
			 $valor = $english_format_number = number_format($valor, 2, '.', '');
			 $this->Cell(21,4,$valor,1,1,'R');
		 
		 }
		 $this->Cell(170,4,'Total Retenido: ',0,0,'R');
		 $valor = $english_format_number = number_format($totret, 2, '.', '');
		 $this->Cell(21,4,$totret,1,1,'R');	
	   
	}      
	
	function transportista($pruc,$prazons,$placa,$dirpartida,$fpartida,$fllegada){
		$alto = 5;
		//$this->Cell(90,2,'',0,1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Identificacion Transportista '),'TL',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$pruc,'TR',1,'L');
		//$alto = $y2 - $y1 ;
		$alto = 5 ;
		$this->SetFont('helvetica','B',8);
		$this->SetXY(10,112);
		$this->Cell(60,$alto,utf8_decode('Razon Social / Nombres: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','B',9);
		$this->SetXY(70,113);
		$y1 = $this->GetY();
		$x1 = $this->GetX();	
		$this->SetFillColor(255,255,255);
		$this->SetFont('helvetica','',8);
		if (strlen(trim($prazons)) >= 70){
			$this->Cell(131,5,''.substr($prazons,0,70),'R',1,'L');
			$slinea = 'T';
		}	else {
			$this->Cell(131,5,''.$prazons,'R',1,'L');
			$slinea = 'F';
		}	
		
		
		if ($slinea == 'T'){
			$this->SetXY(10,118);
			$this->Cell(191,5,''.substr($prazons,71,119),'LR',1,'L');
		}
		$this->SetFont('helvetica','B',8);	
		$this->Cell(60,5,utf8_decode('Placa '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$placa,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Punto de Partida '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$dirpartida,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Fecha inicio Transporte '),'BL',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(41,5,''.$fpartida,'B',0,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(50,5,utf8_decode('Fecha fin Transporte '),'B',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(40,5,''.$fllegada,'BR',1,'L');
	}
	
	function datosguia($nuemef,$fechaf,$numaut,$motivo,$dirllegada,$cruc,$crazons,$docaduanero,$sucursalcod,$rutac){
		$this->Cell(90,2,'',0,1,'L');
		$this->SetFont('helvetica','B',2);
		//$this->Ln();
		$numdoc = 'FACTURA';
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Comprobante de Venta: '),'TL',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(21,5,''.$numdoc,'T',0,'L');
		$this->Cell(50,5,''.substr($nuemef,0,3).'-'.substr($nuemef,3,3).'-'.substr($nuemef,6,9),'T',0,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(30,5,utf8_decode('Fecha de Emision: '),'T',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(30,5,''.$fechaf,'TR',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Numero de Autorizacion: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$numaut,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Motivo de traslado: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$motivo,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Destino (Punto de llegada): '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$dirllegada,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Identificacion (Destinatario): '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$cruc,'R',1,'L');
		
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Razon Social / Nombres y Apellidos: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		if (strlen(trim($crazons)) >= 70){
			$this->Cell(131,5,''.substr($crazons,0,70),'R',1,'L');
			$slinea = 'T';
		}	else {
			$this->Cell(131,5,''.$crazons,'R',1,'L');
			$slinea = 'F';
		}	
		
		if ($slinea == 'T'){
			$filal = $this->GetY();
			$this->SetXY(10,$filal);
			$this->Cell(191,5,''.substr($crazons,71,119),'LR',1,'L');
		}
		
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Documento Aduanero: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$docaduanero,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Codigo establecimiento Destino: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$sucursalcod,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Ruta: '),'LB',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$rutac,'RB',1,'L');
		
	}
	
	
	
	function datosguiafg($nuemef,$fechaf,$numaut,$dirllegada,$cruc,$crazons){
		$this->Cell(90,2,'',0,1,'L');
		$this->SetFont('helvetica','B',2);
		//$this->Ln();
		$numdoc = 'FACTURA';
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Comprobante de Venta: '),'TL',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(21,5,''.$numdoc,'T',0,'L');
		$this->Cell(50,5,''.substr($nuemef,0,3).'-'.substr($nuemef,3,3).'-'.substr($nuemef,6,9),'T',0,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(30,5,utf8_decode('Fecha de Emision: '),'T',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(30,5,''.$fechaf,'TR',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Numero de Autorizacion: '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$numaut,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Destino (Punto de llegada): '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$dirllegada,'R',1,'L');
		$this->SetFont('helvetica','B',8);
		$this->Cell(60,5,utf8_decode('Identificacion (Destinatario): '),'L',0,'L'); //Titulo del reporte
		$this->SetFont('helvetica','',8);
		$this->Cell(131,5,''.$cruc,'R',1,'L');
		
		if (strlen(trim($crazons)) >= 70){
			$this->SetFont('helvetica','B',8);
			$this->Cell(60,5,utf8_decode('Razon Social / Nombres y Apellidos: '),'L',0,'L'); //Titulo del reporte
			$this->SetFont('helvetica','',8);
			$this->Cell(131,5,''.substr($crazons,0,70),'R',1,'L');
			$slinea = 'T';
		}	else {
			$this->SetFont('helvetica','B',8);
			$this->Cell(60,5,utf8_decode('Razon Social / Nombres y Apellidos: '),'LB',0,'L'); //Titulo del reporte
			$this->SetFont('helvetica','',8);
			$this->Cell(131,5,''.$crazons,'RB',1,'L');
			$slinea = 'F';
		}	
		
		if ($slinea == 'T'){
			$filal = $this->GetY();
			$this->SetXY(10,$filal);
			$this->Cell(191,5,''.substr($crazons,71,119),'LRB',1,'L');
		}
		
				
	}
	
	
	function cabeceraguia(){
		$this->SetFillColor(111,159,171);
		$this->Cell(90,2,'',0,1,'L');
		$this->SetFont('helvetica','',2);
		//$this->Ln();
		$this->SetFont('helvetica','B',8);
		$this->Cell(20,6,'',0,0,'C');
		$this->Cell(15,6,'Cantidad',1,0,'C','true'); //ancho,alto,dato,borde,salto,alineacion centrado**
		$this->Cell(80,6,'Descripcion',1,0,'C','true'); //**
		$this->Cell(25,6,'Codigo Principal',1,0,'C','true'); //**
		$this->Cell(25,6,'Codigo Auxiliar',1,1,'C','true'); //**
	}
	
	function detalleguia($factid,$cn,$tipog,$codaltpro){
		if ($tipog == 'G'){
			$sql = "SELECT d.Guiadetallecantidad,d.ProductoservicioId,p.productoservicionombre,p.productoservicionomgenerico,p.productoserviciodescripcion FROM guiasdetalles d,productoservicio p WHERE d.guiaid = $factid and d.productoservicioid = p.productoservicioid";
		} elseif($tipog == 'F'){
			$sql = "SELECT d.facturadetallecantidad,d.ProductoservicioId,p.productoservicionombre,p.productoservicionomgenerico,p.productoserviciodescripcion FROM facturadetalle d,productoservicio p WHERE d.facturaid = $factid and d.productoservicioid = p.productoservicioid";
		}	
		
		if (!$resultado = $cn->query($sql)) {
        		
		echo "Lo sentimos, problemas al buscar datos detalle guia dentro en pdf.";
		exit;
        }
        $coddocsustento = '01';
        while($fila2 = $resultado->fetch_assoc()){
			 $this->SetFont('helvetica','',8);
			 $tline = 0;
			 $tline = 0;
			 $alto = 4;
			 $ubicaf = $this->GetY();
			 $this->SetXY(45,$ubicaf);
			 $y1 = $this->GetY();
			 $x1 = $this->GetX(); 
			 
			 $this->MultiCell(80,4,$fila2['productoservicionombre'],1,'1'); 
			 $y2 = $this->GetY();
	 		 $alto = $y2 - $y1 ;
			 $this->SetXY(30,$ubicaf);
			 //$this->Cell(20,4,'',0,0,'R');
			 if ($tipog == 'G'){		 
			 	$this->Cell(15,$alto,$fila2['Guiadetallecantidad'],1,0,'L'); //Celda con ancho de 50, alto de 10, el dato, borde 1, sin salto de linea**
			 } elseif($tipog == 'F'){
			 	$this->Cell(15,$alto,$fila2['facturadetallecantidad'],1,0,'L'); 
			 }	
			 //$this->Cell(80,4,$fila2['Guiadetalleproductoservicionombre'],1,0); //id 
			 if ($codaltpro== 0){
		 		$fdid= $fila2['ProductoservicioId'];
			 } elseif ($codaltpro== 1){
			 	$fdid= $fila2['productoservicionomgenerico'];
			 } 
			 $this->SetXY(125,$ubicaf);
			 $this->Cell(25,$alto,$fdid,1,0,'C'); //**
			 $this->SetXY(150,$ubicaf);
			 $this->Cell(25,$alto,'',1,1,'R'); //** 
			 $ubicaf = $ubicaf + $alto;		 
		 }

	}
	
	
	
	function destinoguia($factid,$cn){
		$sql = "SELECT destinoguiasmotivo,SucursalCodigo,DocAduaneroUnico,destinoguiasRuta FROM destinoguias WHERE facturaid = $factid ";
			
		if (!$resultado = $cn->query($sql)) {
        		
    		echo "Lo sentimos, problemas al buscar datos destino guia dentro pdf.";
    		exit;
        }
        $coddocsustento = '01';
        while($fila2 = $resultado->fetch_assoc()){
			 $this->SetFont('helvetica','',8);
			 $tline = 0;
			 $tline = 0;
			 $alto = 4;
			 $ubicaf = $this->GetY();
			 $this->SetXY(10,$ubicaf);
			 $y1 = $this->GetY();
			 $x1 = $this->GetX(); 
			 
			 $this->MultiCell(85,4,$fila2['destinoguiasmotivo'],1,'1'); 
			 $y2 = $this->GetY();
	 		 $alto = $y2 - $y1 ;
			 $this->SetXY(95,$ubicaf);
			 //$this->Cell(20,4,'',0,0,'R');		 
			 $this->Cell(20,$alto,$fila2['SucursalCodigo'],1,0,'C'); //Celda con ancho de 50, alto de 10, el dato, borde 1, sin salto de linea**
			 //$this->Cell(80,4,$fila2['Guiadetalleproductoservicionombre'],1,0); //id 
			 
			 $this->SetXY(115,$ubicaf);
			 $this->Cell(20,$alto,$fila2['DocAduaneroUnico'],1,0,'C'); //**
			 
			 $this->SetXY(135,$ubicaf);
			 $this->Cell(66,$alto,$fila2['destinoguiasRuta'],1,1,'L'); //**

			 
			 $ubicaf = $ubicaf + $alto;		 
			 

	      }
	}
	
	
	function infoadicional($corcliente,$telcliente,$factid){
		//$this->Cell(15,7,'',0,0,'L'); 
		
		$this->Cell(130,5,'INFORMACION ADICIONAL',0,1,'C');
		
		$this->Cell(28,5,'CORREO: ','TL',0,'L');
		$this->Cell(100,5,$corcliente,'TR',1,'L');
		
		$this->Cell(28,5,'TELEFONO: ','LB',0,'L');
		$this->Cell(30,5,$telcliente,'B',0,'L');
		$this->Cell(35,5,'Referencia','B',0,'L');
		$this->Cell(35,5,$factid,'BR',1,'L');
		$this->Cell(2,5,'',0,0,'L');
		//$this->Cell(130,5,'',0,0,'L');
		
	}
}

?>
